var GeoZoneWindow;
var bermudaTriangleArray = new Array();
var color = '#7bc3b5';

Ext.define('Ext.ux.ColorPickerCombo', {
        extend: 'Ext.form.field.Trigger',
        alias: 'widget.colorcbo',
        triggerTip: 'Please select a color.',
        picker: null,
        onTriggerClick: function() {
                var me = this;
                if(!me.picker) {
                        me.picker = Ext.create('Ext.picker.Color', {    
                                pickerField: this,    
                                ownerCt: this,    
                                renderTo: document.body,    
                                floating: true,    
                                hidden: false,    
                                focusOnShow: true,
                                style: {
                                        backgroundColor: "#fff"
                                } ,
                                listeners: {
                                        scope:this,
                                        select: function(field, value, opts){
                                                me.setValue('#' + value);
                                                me.inputEl.setStyle({backgroundColor:value});
                                                me.picker.hide();
                                        },
                                        show: function(field,opts){
                                                field.getEl().monitorMouseLeave(500, field.hide, field);
                                        },
                                }
                        });
                        me.picker.alignTo(me.inputEl, 'tl-bl?');
                        me.picker.show(me.inputEl);
                }
                else {
                        if(me.picker.hidden) {
                                me.picker.show();
                        }
                        else {
                                me.picker.hide();
                        }
                }
        },
});

//-----------------window-----------------------------------------------------   
function showGeoZoneWindow(){
    
	var PanelMap = Ext.create('Ext.ux.GMapPanel', {
        //title: 'Положение на карте',
        zoomLevel:11,
        gmapType: 'map',
        padding: 170, 
        //width: 325,
        //height: '50%', 
        mapConfOpts: ['enableScrollWheelZoom','enableDoubleClickZoom','enableDragging'],
        setCenter: {
            lat:'50.5',
            lng:'30.5'
        }
    });
	
	Ext.define('data_model', {
        extend: 'Ext.data.Model',
        fields: ['Zone_ID', 'Name', {name: 'indoor', type: 'bool'}]
    });
	var data_store = new Ext.data.Store({
        autoLoad: true,
        autoDestroy: true,
        model: 'data_model',
        proxy: {
            type: 'ajax',
            url: 'scripts/GeoZone.php?storezone=1',
            reader: {
                type: 'json',
                root: 'rows',
            },
        }
    });
	
	

var customColors = [
        'fa7166', 'cf2424', 'a01a1a', '7e3838', 'ca7609', 'f88015', 'eda12a', 'd5b816',
        'e281ca', 'bf53a4', '9d3283', '7a0f60', '542382', '7742a9', '8763ca', 'b586e2',
        '7399f9', '4e79e6', '2951b9', '133897', '1a5173', '1a699c', '3694b7', '64b9d9',
        'a8c67b', '83ad47', '2e8f0c', '176413', '0f4c30', '386651', '3ea987', '7bc3b5', '780000ff'
];
var pickerMenu = Ext.create('Ext.menu.ColorPicker',{    
listeners: {
        scope:this,
		select: function(picker, selColor) {
            //console.log(btn);
			
			btn.style.background = '#'+selColor;
			
			//picker.setValue('#' + selColor);
            //btn.btnEl.setStyle({backgroundColor:selColor});
            btn.setStyle({backgroundColor:selColor});
			//picker.hide();
			
			
			//btn.style.background = '#'+selColor;
			//btn.setStyle('background', '#'+selColor);
			//btn.applyStyles({'background':'#'+selColor});
        }
    }
});
pickerMenu.picker.colors = customColors;
var btn = Ext.create('Ext.Button', {
    menu: pickerMenu, // menu
    id: 'pickercolorszone',
	name: 'pickercolors',
	width: 30,
	frame: false,
	border: false,
	style: {
            //marginBottom: '10px',
			background: color,
        } 
	//renderTo: Ext.getBody(),
    //text: 'Menu Button'
});
	
var form = new Ext.create('Ext.form.Panel', {
				autoScroll: true,
				bodyPadding: '6 5 5 6',
				border: false,
				frame: false,
				id: 'GeoZoneForm',
				//autoHeight:true,
				//labelWidth: 200,
				layout: {
                    type: 'vbox',
                    align: 'stretch'
                },
				defaults: {
					//fileUpload: true,
					//labelAlign: 'top',
					//labelWidth: 200,
					msgTarget: 'side'
				},
				items:[
					{
                    xtype:'textfield',
                    fieldLabel: 'Назва',
					allowBlank: false,
                    name: 'Name',
					},
					{
                    xtype:'textfield',
                    fieldLabel: 'Описание',
                    name: 'Comments',
					},
					{
                    xtype:'combo',
					fieldLabel: 'Тип',
                    name: 'Comments',
					id: 'pickertyperzone',
					value: 'POLYGON',
					store: new Ext.data.Store({fields:['id','type'],data:[
					{"id":"POLYGON", "type":"Полигон"},
					{"id":"RECTANGLE", "type":"Прямоугольник"},
					{"id":"CIRCLE", "type":"Круг"}
					]}),
					//queryMode: 'local',
                    displayField: 'type',
                    valueField: 'id',
					},
					btn,
/*new Ext.create('Ext.picker.Color', {
    value: '993300',  // initial selected color
    //renderTo: Ext.getBody(),
    listeners: {
        select: function(picker, selColor) {
            alert(selColor);
        }
    }
})*/
				],
				buttons:[
					{ 
                    text:'Сохранить',
					iconCls:'save',
					handler: function() {			
						var form = this.up('form').getForm();
						if(form.isValid()){
						
								//console.log(PanelMap);
								//console.log(PanelMap.getMap());
								var type = Ext.getCmp('pickertyperzone').getValue();
								var contentLatLng = new Array;
								var radius = null;
								
								switch (type) {
								case 'POLYGON':
									var vertices = flightPath.getPath();
									for (var i =0; i < vertices.length; i++) {
									var xy = vertices.getAt(i);
										contentLatLng.push(xy.lat() +" " + xy.lng());
									}
								break
								case 'RECTANGLE':
									console.log(flightPath.bounds);
								break
								case 'CIRCLE':
									console.log(flightPath.center.lat());
									console.log(flightPath.center.lng());
									contentLatLng.push(flightPath.center.lat() +" " + flightPath.center.lng());
									radius = flightPath.radius;
								break
								}
						
						form.submit({
							url: 'scripts/GeoZone.php',
							waitMsg: 'Сохранение...',
							wait: true,
							scope: this,
							method: 'post',
							//timeout : 60000,
							params: {'add':true, radius:radius, 'contentLatLng[]':contentLatLng, color:Ext.getCmp('pickercolorszone').style.background, type:type },
							success: function(fp, o) {
								if(o.result.success){
									Ext.MessageBox.alert('Выполнено', 'Зона успешно сохранена');
									Ext.getCmp('GeoZoneToolbar').setVisible(true);
									Ext.getCmp('GeoZoneFormPanel').setVisible(false);
									PanelMap.clearMapZone();
									Ext.getCmp('GeoZoneForm').getForm().reset();
									Ext.getCmp('GeoZoneGrid').store.load();
									Ext.getCmp('GeoZoneGrid').getView().refresh();
								}else{
									Ext.MessageBox.alert('Ошибка', o.result.message);
								}
								
							},
							failure: function(fp, o) {
								Ext.MessageBox.alert('Ошибка', o.result.message);
							}
						});
						}
					}
                    },
					{ 
                    text:'Отмена',
					iconCls: 'cancel',
                    handler:function(){
						Ext.getCmp('GeoZoneToolbar').setVisible(true);
						Ext.getCmp('GeoZoneFormPanel').setVisible(false);
						//flightPath.setMap(null);
						PanelMap.clearMapZone();
						Ext.getCmp('GeoZoneForm').getForm().reset(); 
						Ext.getCmp('pickertyperzone').setDisabled(false);
						Ext.getCmp('pickercolorszone').setDisabled(false);
                    }
					}
				]
});
	
	
	
	//var grid = {
    //    xtype: 'grid',
var grid = new Ext.grid.GridPanel({    
		layout: 'fit', //new Ext.grid.GridPanel({
        //forceFit: false,
        columnLines: true,
        border: false,
        frame: false,
        //autoHeight: true,
        id: 'GeoZoneGrid',
        autoScroll: true,
        store: data_store,
        viewConfig: {
            stripeRows: true,
			//selectedItemCls: 'red'
        },
        dockedItems: [
            {
                xtype: 'toolbar',
                border: false,
				id: 'GeoZoneToolbar',
                items: [
                    {
                        text: 'Создать',
                        iconCls: 'add',
                        handler: function() {
                            //ShowWindowFormRef(true, id);
							//Ext.getCmp('GeoZoneToolbar').hide();
							//Ext.getCmp('GeoZoneToolbar').setHidden(true);
							
							Ext.getCmp('GeoZoneToolbar').setVisible(false);
							Ext.getCmp('GeoZoneFormPanel').setVisible(true);
							
							PanelMap.clickOnMapZone();
                        }
                    },
                    /*{
                        text: 'Редактировать',
                        iconCls: 'edit',
                        handler: function() {
                            var select = Ext.getCmp(id).getView().getSelectionModel().getSelection()[0];
                            if (select) {
                                ShowWindowFormRef(false, id, select.get('id'));
                            } else {
                                Ext.MessageBox.alert('Помилка', 'Виберіть запис таблиці');
                            }
                        }
                    },*/
                    {
                        text: 'Удалить',
                        iconCls: 'delete',
                        handler: function() {
                            //var select = Ext.getCmp('GeoZoneGrid').getView().getSelectionModel().getSelection()[0];
                            
							var arrayId=[];									
							grid.store.each(function(record){
								var indoor = record.get('indoor');
								if(indoor == true){
									arrayId.push(record.get('Zone_ID'));
								}
							});

							if(arrayId.length!=0){
								Ext.MessageBox.confirm('Удаление', 'Вы действительно хотите удалить зону(ы)?', function(btn) {
                                    if (btn == 'yes') {
            //console.log(arrayId);
										Ext.Ajax.request({
                                            url: 'scripts/GeoZone.php',
                                            method: 'POST',
                                            params: {"delete": true, 'arrayDelete[]':arrayId},
                                            success: function(response) {
                                                //var jsn = Ext.decode(response.responseText);
												//console.log(jsn.message);
												Ext.MessageBox.alert('Выполнено', 'Зона(ы) успешно удалена(ы)');
                                                grid.store.load();
                                            },
                                            failure: function(response) {
                                                //console.log(response.responseText);
												var jsn = Ext.decode(response.responseText);
												Ext.MessageBox.alert('Ошибка', jsn.message);
                                            }
                                        });
                                    }
                                });
							}else{
								Ext.MessageBox.alert('Ошибка', 'Выберите зону');
							}
							
							
                        }
                    }
                ]
            }
        ],
        columns: [
			{xtype: 'checkcolumn', dataIndex: 'indoor', sortable: false, hideable: false, width: 30,
			listeners:
            {
                checkchange:function(CheckColumn, rowIndex, checked, eOpts )
                {
                    var record = grid.store.getAt(rowIndex);
					var id = record.get('Zone_ID');
                    if (checked==true)
                    {
						//console.log(record.get('Zone_ID'));
						Ext.Ajax.request({
                            url: 'scripts/GeoZone.php',
                            method: 'POST',
                            params: {"edit": id},
                            success: function(response) {
                                var obj = Ext.decode(response.responseText);
								var color = '#'+obj.colors;
								obj = obj.coords
								
								var triangleCoords = new Array();
								for(key in obj){
									//console.log( obj[key] );
									var row = new google.maps.LatLng(obj[key].x, obj[key].y);
									triangleCoords.push(row);
								}
								//var color = '#'+(function co(lor){ return (lor +=[0,1,2,3,4,5,6,7,8,9,'a','b','c','d','e','f'][Math.floor(Math.random()*16)]) && (lor.length == 6) ?  lor : co(lor); })('');
								var bermudaTriangle = new google.maps.Polygon({
									paths: triangleCoords,
									strokeColor: color,
									strokeOpacity: 0.8,
									strokeWeight: 2,
									fillColor: color,
									fillOpacity: 0.35
								});

								//bermudaTriangleArray.push(bermudaTriangle);
								bermudaTriangleArray.push({ id: id, obj: bermudaTriangle });
								bermudaTriangle.setMap(PanelMap.getMap());
                            },
                            failure: function(response) {
								var jsn = Ext.decode(response.responseText);
								//console.log(jsn);
                            }
                        });
                    }else{
						console.log( bermudaTriangleArray );
						for(key in bermudaTriangleArray){
							if(id == bermudaTriangleArray[key].id){
								bermudaTriangleArray[key].obj.setMap(null);
								bermudaTriangleArray.splice(delete_number,1); 
							}
						}
					}
                }
            }
			},
			//{xtype: 'rownumberer', width: 40, sortable: false, hideable: false},
			{text: 'Назва', dataIndex: 'Name', sortable: true, hideable: false, flex: 1},
		],
        listeners: {
            itemclick: function(View, record, item, index, e, eOpts) {
                //var select = record.get('Zone_ID');
				//console.log(select);
				Ext.getCmp('GeoZoneToolbar').setVisible(false);
				Ext.getCmp('GeoZoneFormPanel').setVisible(true);
				
				//var form = Ext.getCmp('GeoZoneForm').getForm();
				var form = Ext.getCmp("GeoZoneForm").getForm().getFields();
				//console.log(form);
				
				form.items[0].setValue(record.get('Name'));
				form.items[1].setValue(record.get('Comments'));
				//form.items[2].setStyle({backgroundColor:record.get('PenColorInt').toString(16)});
				Ext.getCmp('GeoZoneForm').getForm().findField("pickercolors").setStyle({backgroundColor:record.get('PenColorInt').toString(16)});
				
				
				//form.each(function(item) {
                //});
            }
        }
    //}
	});
	
	if (!CarsStopTPWindow){
		
        Ext.getBody().mask('Обработка...');
        GeoZoneWindow = new Ext.Window({
            layout : 'border', 
            title : 'Геозоны',
            closeAction: 'destroy',
            width : 800,
            height : 500,
            //minimizable: true,
            maximizable:true,
			constrainHeader: true,
			listeners: {
                destroy: function(){
                    GeoZoneWindow = null;
                }
            },
            defaults: {
				collapsible: true,
				split: true,
				//bodyStyle: 'padding:15px'
            },
			items:[
				{
                collapsible: true,
                region:'west',
                margins:'5 0 5 5',
                split:true,
                width: 325,
                //layout:'fit',
				layout: 'border',
                items:[
					
					{
					region:'north',
					//margins:'5 0 5 5',
					id: 'GeoZoneFormPanel',
					hidden: true,
					layout:'fit',
					height: '40%',
					items:[
						form
					]
					},{
					region:'center',
					//margins:'5 0 5 5',
					layout:'fit',
					height: '60%',
					items:[
						grid
					]
					}
					
				]
			    },
				{
                //title: 'Результаты отчета',
                layout: 'fit',
			    collapsible: false,
                region:'center',
                margins: '5 5 5 0',
                items:[
					PanelMap
				]
			    }
			],
            
        });
        GeoZoneWindow.show();
        Ext.getBody().unmask('Обработка...');
		
    }
	
	
	
Ext.getCmp('GeoZoneGrid').getView().on('render', function(view) {
    alert(view);
	view.tip = Ext.create('Ext.tip.ToolTip', {
        target: view.el,
        delegate: view.cellSelector,
        trackMouse: true,
        listeners: {
            beforeshow: function updateTipBody(tip) {
                var gridColums = view.getGridColumns();
                var column = gridColums[tip.triggerElement.cellIndex];
                var val=view.getRecord(tip.triggerElement.parentNode).get(column.dataIndex);

				tip.update('');

				alert(val);
				//if(column.id=='caractioncolumn'){
				//	tip.update('Настройки объекта');
				//}
	 
				//var adr = view.getRecord(tip.triggerElement.parentNode).get('adres_car_monit');
				//adr = adr ? adr : "";
	
				if(column.dataIndex=='Name'){
					tip.update( 'Следить за объектом на карте' );
				}
			}
		}
    });
}); 
	
}